> ## Documentation Index
> Fetch the complete documentation index at: https://docs.campfire.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List Revenue Contract Lines



## OpenAPI

````yaml https://api.meetcampfire.com/api/schema?format=json get /rev/api/v1/contract-lines
openapi: 3.0.3
info:
  title: Campfire Developer APIs
  version: 1.0.0
  description: >
    ## Introduction

    Campfire's developer APIs offer granular access to Campfire's core
    accounting,

    revenue recognition, and financial data features.


    These APIs are designed to be used by developers to build custom
    integrations,

    automate workflows, and perform any other programmatic operations.


    ## Rate limits

    API users can make up to **5 requests per second**. This limit is shared
    across

    all endpoints for the same API user. Requests that exceed the limit receive
    a

    `429 Too Many Requests` response. Wait for the number of seconds specified
    in

    the `Retry-After` response header before retrying.
servers:
  - url: https://api.meetcampfire.com
    description: Production server
security: []
tags:
  - name: Cash Management
    description: Operations related to accounts, transactions, and other bank-related data.
  - name: Core Accounting
    description: >-
      Operations related to core accounting data, such as the chart of accounts,
      entity management, and the general ledger.
  - name: Revenue Recognition
    description: >-
      Operations related to revenue recognition, contract management, and
      contract data aggregation.
  - name: Accounts Receivable
    description: Operations related to invoicing and the AR subledger
  - name: Accounts Payable
    description: Operations related to billing and the AP subledger.
  - name: Financial Statements
    description: Operations related to financial statement generation and data aggregation.
  - name: Settings
    description: Operations related to system and accounting settings configuration.
paths:
  /rev/api/v1/contract-lines:
    get:
      tags:
        - Revenue
      summary: List Revenue Contract Lines
      operationId: rev_api_v1_contract_lines_list
      parameters:
        - name: limit
          required: false
          in: query
          description: Number of results to return per page.
          schema:
            type: integer
        - name: offset
          required: false
          in: query
          description: The initial index from which to return the results.
          schema:
            type: integer
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedRevenueContractLineList'
          description: ''
      security:
        - knoxApiToken: []
components:
  schemas:
    PaginatedRevenueContractLineList:
      type: object
      required:
        - count
        - results
      properties:
        count:
          type: integer
          example: 123
        next:
          type: string
          nullable: true
          format: uri
          example: http://api.example.org/accounts/?offset=400&limit=100
        previous:
          type: string
          nullable: true
          format: uri
          example: http://api.example.org/accounts/?offset=200&limit=100
        results:
          type: array
          items:
            $ref: '#/components/schemas/RevenueContractLine'
    RevenueContractLine:
      type: object
      description: |-
        Base serializer that injects the request user's customer on create and
        restricts related-object querysets to the same customer.
      properties:
        id:
          type: integer
          readOnly: true
        contract:
          type: integer
        contract_name:
          type: string
          readOnly: true
        ordinal:
          type: integer
          maximum: 2147483647
          minimum: 0
        product:
          type: integer
          nullable: true
        product_bundle:
          type: integer
          nullable: true
        product_name:
          type: string
          maxLength: 255
        product_sku:
          type: string
          maxLength: 255
        description:
          type: string
        currency:
          type: string
          maxLength: 3
        quantity:
          type: number
          format: double
          maximum: 100000000000
          minimum: -100000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
        unit_price:
          type: number
          format: double
          maximum: 1000000000
          minimum: -1000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
        discount:
          type: number
          format: double
          maximum: 10000000000000
          minimum: -10000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
        transaction_price:
          type: number
          format: double
          maximum: 10000000000000
          minimum: -10000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
        service_start:
          type: string
          format: date
          nullable: true
        service_end:
          type: string
          format: date
          nullable: true
        exclude_from_allocation:
          type: boolean
        is_mrr:
          type: boolean
        billing_cadence:
          $ref: '#/components/schemas/BillingCadenceEnum'
        billing_timing:
          $ref: '#/components/schemas/BillingTimingEnum'
        net_terms:
          type: integer
          maximum: 2147483647
          minimum: 0
          nullable: true
        created_at:
          type: string
          format: date-time
          readOnly: true
        last_modified_at:
          type: string
          format: date-time
          readOnly: true
      required:
        - contract
        - contract_name
        - created_at
        - id
        - last_modified_at
        - product_name
    BillingCadenceEnum:
      enum:
        - MONTHLY
        - QUARTERLY
        - SEMI_ANNUAL
        - ANNUAL
        - CUSTOM
      type: string
      description: |-
        * `MONTHLY` - Monthly
        * `QUARTERLY` - Quarterly
        * `SEMI_ANNUAL` - Semi-annual
        * `ANNUAL` - Annual
        * `CUSTOM` - Custom
    BillingTimingEnum:
      enum:
        - ADVANCE
        - ARREARS
      type: string
      description: |-
        * `ADVANCE` - In advance (start of period)
        * `ARREARS` - In arrears (end of period)
  securitySchemes:
    knoxApiToken:
      type: apiKey
      in: header
      name: Authorization
      description: Token-based authentication with required prefix "Token"

````